# External Actions (Core)

Endpoints to attach external actions to processes and append logs to external actions.

## List external actions

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Returns a list with all external actions.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ExternalAction":{"allOf":[{"$ref":"#/components/schemas/ExternalActionForReplacement"},{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"id":{"description":"The id of this external action. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"name":{"description":"The name of this external action.","type":"string"},"processRef":{"description":"Id of the global process related to this entity.","type":"string"}},"required":["id","name","processRef"],"type":"object","xml":{"name":"ExternalAction"},"title":"ExternalAction","description":"ExternalAction"},"ExternalActionForReplacement":{"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"action":{"oneOf":[{"$ref":"#/components/schemas/ExternalFormActionDefinition"},{"$ref":"#/components/schemas/ExternalLinkActionDefinition"},{"$ref":"#/components/schemas/ExternalCommentActionDefinition"}],"discriminator":{"propertyName":"type","mapping":{"BLANK_LINK":"#/components/schemas/ExternalLinkActionDefinition","COMMENT":"#/components/schemas/ExternalCommentActionDefinition","FORM":"#/components/schemas/ExternalFormActionDefinition"}}},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"groups":{"items":{"description":"User-defined text strings for grouping external actions","type":"string"},"type":"array"},"version":{"format":"int64","type":"integer"}},"required":["version","nameLocalized","groups","action"],"type":"object","xml":{"name":"ExternalActionForReplacement"},"title":"ExternalActionForReplacement","description":"ExternalActionForReplacement"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ExternalFormActionDefinition":{"additionalProperties":false,"description":"External Form Action.","properties":{"cancel":{"$ref":"#/components/schemas/ExternalFormActionButton"},"elements":{"items":{"anyOf":[{"$ref":"#/components/schemas/ExternalFormActionElement"},{"$ref":"#/components/schemas/ExternalFormActionInputElement"}],"discriminator":{"propertyName":"elementType","mapping":{"HEADLINE":"#/components/schemas/ExternalFormActionElement","SUBHEADLINE":"#/components/schemas/ExternalFormActionElement","TEXT":"#/components/schemas/ExternalFormActionElement","TEXT_INPUT":"#/components/schemas/ExternalFormActionInputElement"}}},"minItems":1,"type":"array"},"success":{"$ref":"#/components/schemas/ExternalFormActionButton"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["elements","type","cancel"],"title":"ExternalFormActionDefinition","type":"object","xml":{"name":"ExternalFormActionDefinition"}},"ExternalFormActionButton":{"additionalProperties":false,"properties":{"labelLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"label":{"type":"string"}},"required":["labelLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionButton","description":"ExternalFormActionButton"},"ExternalFormActionElement":{"properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"style":{"description":"it is only allowed to set a style for elementType TEXT","enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"}},"required":["elementType","titleLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionElement","description":"ExternalFormActionElement"},"ExternalFormActionElementType":{"enum":["TEXT_INPUT","HEADLINE","SUBHEADLINE","TEXT"],"type":"string","title":"ExternalFormActionElementType","description":"ExternalFormActionElementType"},"ExternalFormActionInputElement":{"additionalProperties":false,"description":"External Form Input Action.","properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementId":{"type":"string"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"isMandatory":{"type":"boolean"},"style":{"enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"},"validation":{"anyOf":[{"$ref":"#/components/schemas/StringValidation"},{"$ref":"#/components/schemas/IntegerValidation"},{"$ref":"#/components/schemas/FloatValidation"}],"discriminator":{"propertyName":"validationType","mapping":{"FLOAT":"#/components/schemas/FloatValidation","INTEGER":"#/components/schemas/IntegerValidation","STRING":"#/components/schemas/StringValidation"}}}},"required":["elementId","titleLocalized","elementType"],"title":"ExternalFormActionInputElement","type":"object","xml":{"name":"ExternalFormActionInputElement"}},"StringValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as string.","properties":{"maxLength":{"type":"number"},"minLength":{"type":"number"}},"title":"StringValidation","type":"object"},"BaseValidation":{"properties":{"validationType":{"enum":["STRING","FLOAT","INTEGER"],"type":"string"}},"required":["validationType"],"type":"object","title":"BaseValidation","description":"BaseValidation"},"IntegerValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as integer.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"IntegerValidation","type":"object"},"FloatValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as float.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"FloatValidation","type":"object"},"ExternalActionType":{"description":"The type of an external action","enum":["BLANK_LINK","FORM","COMMENT"],"type":"string","title":"ExternalActionType"},"ExternalLinkActionDefinition":{"additionalProperties":false,"description":"External Link Action.","properties":{"linkUrl":{"type":"string"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["linkUrl","type"],"title":"ExternalLinkActionDefinition","type":"object","xml":{"name":"ExternalLinkActionDefinition"}},"ExternalCommentActionDefinition":{"additionalProperties":false,"description":"This action provides a possibility to set comments. It also enables a possibility to save action results for other actions.","properties":{"isInternal":{"default":false,"description":"Whether or not this action is meant to be internally to the fulfillmenttools platform. If true, an additional entry in the actions dropdown will be added.","type":"boolean"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["type"],"title":"ExternalCommentActionDefinition","type":"object","xml":{"name":"ExternalCommentActionDefinition"}},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions":{"get":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Returns a list with all external actions.","operationId":"getExternalActions","parameters":[{"description":"all entities after given Id.","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}},{"description":"Filter by the given group or groups","explode":true,"in":"query","name":"groups","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"description":"Filter by the given processRef","in":"query","name":"processRef","required":false,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/ExternalAction"},"type":"array"}}},"description":"Returning the list of external actions available."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"External action not found"}},"summary":"List external actions","tags":["External Actions (Core)"]}}}}
```

## Create external action

> Creates a new external action for a process.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ExternalActionForCreation":{"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"action":{"oneOf":[{"$ref":"#/components/schemas/ExternalFormActionDefinition"},{"$ref":"#/components/schemas/ExternalLinkActionDefinition"},{"$ref":"#/components/schemas/ExternalCommentActionDefinition"}],"discriminator":{"propertyName":"type","mapping":{"BLANK_LINK":"#/components/schemas/ExternalLinkActionDefinition","COMMENT":"#/components/schemas/ExternalCommentActionDefinition","FORM":"#/components/schemas/ExternalFormActionDefinition"}}},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"groups":{"items":{"description":"User-defined text strings for grouping external actions","type":"string"},"type":"array"},"processRef":{"description":"Id of the global process related to this entity.","type":"string"}},"required":["processRef","nameLocalized","groups","action"],"type":"object","xml":{"name":"ExternalActionForCreation"},"title":"ExternalActionForCreation","description":"ExternalActionForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ExternalFormActionDefinition":{"additionalProperties":false,"description":"External Form Action.","properties":{"cancel":{"$ref":"#/components/schemas/ExternalFormActionButton"},"elements":{"items":{"anyOf":[{"$ref":"#/components/schemas/ExternalFormActionElement"},{"$ref":"#/components/schemas/ExternalFormActionInputElement"}],"discriminator":{"propertyName":"elementType","mapping":{"HEADLINE":"#/components/schemas/ExternalFormActionElement","SUBHEADLINE":"#/components/schemas/ExternalFormActionElement","TEXT":"#/components/schemas/ExternalFormActionElement","TEXT_INPUT":"#/components/schemas/ExternalFormActionInputElement"}}},"minItems":1,"type":"array"},"success":{"$ref":"#/components/schemas/ExternalFormActionButton"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["elements","type","cancel"],"title":"ExternalFormActionDefinition","type":"object","xml":{"name":"ExternalFormActionDefinition"}},"ExternalFormActionButton":{"additionalProperties":false,"properties":{"labelLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"label":{"type":"string"}},"required":["labelLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionButton","description":"ExternalFormActionButton"},"ExternalFormActionElement":{"properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"style":{"description":"it is only allowed to set a style for elementType TEXT","enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"}},"required":["elementType","titleLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionElement","description":"ExternalFormActionElement"},"ExternalFormActionElementType":{"enum":["TEXT_INPUT","HEADLINE","SUBHEADLINE","TEXT"],"type":"string","title":"ExternalFormActionElementType","description":"ExternalFormActionElementType"},"ExternalFormActionInputElement":{"additionalProperties":false,"description":"External Form Input Action.","properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementId":{"type":"string"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"isMandatory":{"type":"boolean"},"style":{"enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"},"validation":{"anyOf":[{"$ref":"#/components/schemas/StringValidation"},{"$ref":"#/components/schemas/IntegerValidation"},{"$ref":"#/components/schemas/FloatValidation"}],"discriminator":{"propertyName":"validationType","mapping":{"FLOAT":"#/components/schemas/FloatValidation","INTEGER":"#/components/schemas/IntegerValidation","STRING":"#/components/schemas/StringValidation"}}}},"required":["elementId","titleLocalized","elementType"],"title":"ExternalFormActionInputElement","type":"object","xml":{"name":"ExternalFormActionInputElement"}},"StringValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as string.","properties":{"maxLength":{"type":"number"},"minLength":{"type":"number"}},"title":"StringValidation","type":"object"},"BaseValidation":{"properties":{"validationType":{"enum":["STRING","FLOAT","INTEGER"],"type":"string"}},"required":["validationType"],"type":"object","title":"BaseValidation","description":"BaseValidation"},"IntegerValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as integer.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"IntegerValidation","type":"object"},"FloatValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as float.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"FloatValidation","type":"object"},"ExternalActionType":{"description":"The type of an external action","enum":["BLANK_LINK","FORM","COMMENT"],"type":"string","title":"ExternalActionType"},"ExternalLinkActionDefinition":{"additionalProperties":false,"description":"External Link Action.","properties":{"linkUrl":{"type":"string"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["linkUrl","type"],"title":"ExternalLinkActionDefinition","type":"object","xml":{"name":"ExternalLinkActionDefinition"}},"ExternalCommentActionDefinition":{"additionalProperties":false,"description":"This action provides a possibility to set comments. It also enables a possibility to save action results for other actions.","properties":{"isInternal":{"default":false,"description":"Whether or not this action is meant to be internally to the fulfillmenttools platform. If true, an additional entry in the actions dropdown will be added.","type":"boolean"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["type"],"title":"ExternalCommentActionDefinition","type":"object","xml":{"name":"ExternalCommentActionDefinition"}},"ExternalAction":{"allOf":[{"$ref":"#/components/schemas/ExternalActionForReplacement"},{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"id":{"description":"The id of this external action. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"name":{"description":"The name of this external action.","type":"string"},"processRef":{"description":"Id of the global process related to this entity.","type":"string"}},"required":["id","name","processRef"],"type":"object","xml":{"name":"ExternalAction"},"title":"ExternalAction","description":"ExternalAction"},"ExternalActionForReplacement":{"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"action":{"oneOf":[{"$ref":"#/components/schemas/ExternalFormActionDefinition"},{"$ref":"#/components/schemas/ExternalLinkActionDefinition"},{"$ref":"#/components/schemas/ExternalCommentActionDefinition"}],"discriminator":{"propertyName":"type","mapping":{"BLANK_LINK":"#/components/schemas/ExternalLinkActionDefinition","COMMENT":"#/components/schemas/ExternalCommentActionDefinition","FORM":"#/components/schemas/ExternalFormActionDefinition"}}},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"groups":{"items":{"description":"User-defined text strings for grouping external actions","type":"string"},"type":"array"},"version":{"format":"int64","type":"integer"}},"required":["version","nameLocalized","groups","action"],"type":"object","xml":{"name":"ExternalActionForReplacement"},"title":"ExternalActionForReplacement","description":"ExternalActionForReplacement"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions":{"post":{"description":"Creates a new external action for a process.","operationId":"postExternalAction","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalActionForCreation"}}},"description":"The external action to be created","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalAction"}}},"description":"The external action was successfully created."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"External action not found"}},"summary":"Create external action","tags":["External Actions (Core)"]}}}}
```

## Get external action

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Returns an external action with the given id if found.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ExternalAction":{"allOf":[{"$ref":"#/components/schemas/ExternalActionForReplacement"},{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"id":{"description":"The id of this external action. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"name":{"description":"The name of this external action.","type":"string"},"processRef":{"description":"Id of the global process related to this entity.","type":"string"}},"required":["id","name","processRef"],"type":"object","xml":{"name":"ExternalAction"},"title":"ExternalAction","description":"ExternalAction"},"ExternalActionForReplacement":{"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"action":{"oneOf":[{"$ref":"#/components/schemas/ExternalFormActionDefinition"},{"$ref":"#/components/schemas/ExternalLinkActionDefinition"},{"$ref":"#/components/schemas/ExternalCommentActionDefinition"}],"discriminator":{"propertyName":"type","mapping":{"BLANK_LINK":"#/components/schemas/ExternalLinkActionDefinition","COMMENT":"#/components/schemas/ExternalCommentActionDefinition","FORM":"#/components/schemas/ExternalFormActionDefinition"}}},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"groups":{"items":{"description":"User-defined text strings for grouping external actions","type":"string"},"type":"array"},"version":{"format":"int64","type":"integer"}},"required":["version","nameLocalized","groups","action"],"type":"object","xml":{"name":"ExternalActionForReplacement"},"title":"ExternalActionForReplacement","description":"ExternalActionForReplacement"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ExternalFormActionDefinition":{"additionalProperties":false,"description":"External Form Action.","properties":{"cancel":{"$ref":"#/components/schemas/ExternalFormActionButton"},"elements":{"items":{"anyOf":[{"$ref":"#/components/schemas/ExternalFormActionElement"},{"$ref":"#/components/schemas/ExternalFormActionInputElement"}],"discriminator":{"propertyName":"elementType","mapping":{"HEADLINE":"#/components/schemas/ExternalFormActionElement","SUBHEADLINE":"#/components/schemas/ExternalFormActionElement","TEXT":"#/components/schemas/ExternalFormActionElement","TEXT_INPUT":"#/components/schemas/ExternalFormActionInputElement"}}},"minItems":1,"type":"array"},"success":{"$ref":"#/components/schemas/ExternalFormActionButton"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["elements","type","cancel"],"title":"ExternalFormActionDefinition","type":"object","xml":{"name":"ExternalFormActionDefinition"}},"ExternalFormActionButton":{"additionalProperties":false,"properties":{"labelLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"label":{"type":"string"}},"required":["labelLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionButton","description":"ExternalFormActionButton"},"ExternalFormActionElement":{"properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"style":{"description":"it is only allowed to set a style for elementType TEXT","enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"}},"required":["elementType","titleLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionElement","description":"ExternalFormActionElement"},"ExternalFormActionElementType":{"enum":["TEXT_INPUT","HEADLINE","SUBHEADLINE","TEXT"],"type":"string","title":"ExternalFormActionElementType","description":"ExternalFormActionElementType"},"ExternalFormActionInputElement":{"additionalProperties":false,"description":"External Form Input Action.","properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementId":{"type":"string"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"isMandatory":{"type":"boolean"},"style":{"enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"},"validation":{"anyOf":[{"$ref":"#/components/schemas/StringValidation"},{"$ref":"#/components/schemas/IntegerValidation"},{"$ref":"#/components/schemas/FloatValidation"}],"discriminator":{"propertyName":"validationType","mapping":{"FLOAT":"#/components/schemas/FloatValidation","INTEGER":"#/components/schemas/IntegerValidation","STRING":"#/components/schemas/StringValidation"}}}},"required":["elementId","titleLocalized","elementType"],"title":"ExternalFormActionInputElement","type":"object","xml":{"name":"ExternalFormActionInputElement"}},"StringValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as string.","properties":{"maxLength":{"type":"number"},"minLength":{"type":"number"}},"title":"StringValidation","type":"object"},"BaseValidation":{"properties":{"validationType":{"enum":["STRING","FLOAT","INTEGER"],"type":"string"}},"required":["validationType"],"type":"object","title":"BaseValidation","description":"BaseValidation"},"IntegerValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as integer.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"IntegerValidation","type":"object"},"FloatValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as float.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"FloatValidation","type":"object"},"ExternalActionType":{"description":"The type of an external action","enum":["BLANK_LINK","FORM","COMMENT"],"type":"string","title":"ExternalActionType"},"ExternalLinkActionDefinition":{"additionalProperties":false,"description":"External Link Action.","properties":{"linkUrl":{"type":"string"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["linkUrl","type"],"title":"ExternalLinkActionDefinition","type":"object","xml":{"name":"ExternalLinkActionDefinition"}},"ExternalCommentActionDefinition":{"additionalProperties":false,"description":"This action provides a possibility to set comments. It also enables a possibility to save action results for other actions.","properties":{"isInternal":{"default":false,"description":"Whether or not this action is meant to be internally to the fulfillmenttools platform. If true, an additional entry in the actions dropdown will be added.","type":"boolean"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["type"],"title":"ExternalCommentActionDefinition","type":"object","xml":{"name":"ExternalCommentActionDefinition"}},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions/{externalActionId}":{"get":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Returns an external action with the given id if found.","operationId":"getExternalAction","parameters":[{"description":"Id of the external action you want to get","in":"path","name":"externalActionId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/ExternalAction"},"type":"array"}}},"description":"External action was found & you are allowed to get it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"External action not found"}},"summary":"Get external action","tags":["External Actions (Core)"]}}}}
```

## Replace an external action

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Replaces the external action with the provided in the body.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ExternalActionForReplacement":{"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"action":{"oneOf":[{"$ref":"#/components/schemas/ExternalFormActionDefinition"},{"$ref":"#/components/schemas/ExternalLinkActionDefinition"},{"$ref":"#/components/schemas/ExternalCommentActionDefinition"}],"discriminator":{"propertyName":"type","mapping":{"BLANK_LINK":"#/components/schemas/ExternalLinkActionDefinition","COMMENT":"#/components/schemas/ExternalCommentActionDefinition","FORM":"#/components/schemas/ExternalFormActionDefinition"}}},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"groups":{"items":{"description":"User-defined text strings for grouping external actions","type":"string"},"type":"array"},"version":{"format":"int64","type":"integer"}},"required":["version","nameLocalized","groups","action"],"type":"object","xml":{"name":"ExternalActionForReplacement"},"title":"ExternalActionForReplacement","description":"ExternalActionForReplacement"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ExternalFormActionDefinition":{"additionalProperties":false,"description":"External Form Action.","properties":{"cancel":{"$ref":"#/components/schemas/ExternalFormActionButton"},"elements":{"items":{"anyOf":[{"$ref":"#/components/schemas/ExternalFormActionElement"},{"$ref":"#/components/schemas/ExternalFormActionInputElement"}],"discriminator":{"propertyName":"elementType","mapping":{"HEADLINE":"#/components/schemas/ExternalFormActionElement","SUBHEADLINE":"#/components/schemas/ExternalFormActionElement","TEXT":"#/components/schemas/ExternalFormActionElement","TEXT_INPUT":"#/components/schemas/ExternalFormActionInputElement"}}},"minItems":1,"type":"array"},"success":{"$ref":"#/components/schemas/ExternalFormActionButton"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["elements","type","cancel"],"title":"ExternalFormActionDefinition","type":"object","xml":{"name":"ExternalFormActionDefinition"}},"ExternalFormActionButton":{"additionalProperties":false,"properties":{"labelLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"label":{"type":"string"}},"required":["labelLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionButton","description":"ExternalFormActionButton"},"ExternalFormActionElement":{"properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"style":{"description":"it is only allowed to set a style for elementType TEXT","enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"}},"required":["elementType","titleLocalized"],"type":"object","xml":{"name":"ExternalFormActionElement"},"title":"ExternalFormActionElement","description":"ExternalFormActionElement"},"ExternalFormActionElementType":{"enum":["TEXT_INPUT","HEADLINE","SUBHEADLINE","TEXT"],"type":"string","title":"ExternalFormActionElementType","description":"ExternalFormActionElementType"},"ExternalFormActionInputElement":{"additionalProperties":false,"description":"External Form Input Action.","properties":{"titleLocalized":{"$ref":"#/components/schemas/LocaleString","description":"The name of this external action localized"},"elementId":{"type":"string"},"elementType":{"$ref":"#/components/schemas/ExternalFormActionElementType"},"isMandatory":{"type":"boolean"},"style":{"enum":["BODY","INFO","WARN","ERROR"],"type":"string"},"title":{"type":"string"},"validation":{"anyOf":[{"$ref":"#/components/schemas/StringValidation"},{"$ref":"#/components/schemas/IntegerValidation"},{"$ref":"#/components/schemas/FloatValidation"}],"discriminator":{"propertyName":"validationType","mapping":{"FLOAT":"#/components/schemas/FloatValidation","INTEGER":"#/components/schemas/IntegerValidation","STRING":"#/components/schemas/StringValidation"}}}},"required":["elementId","titleLocalized","elementType"],"title":"ExternalFormActionInputElement","type":"object","xml":{"name":"ExternalFormActionInputElement"}},"StringValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as string.","properties":{"maxLength":{"type":"number"},"minLength":{"type":"number"}},"title":"StringValidation","type":"object"},"BaseValidation":{"properties":{"validationType":{"enum":["STRING","FLOAT","INTEGER"],"type":"string"}},"required":["validationType"],"type":"object","title":"BaseValidation","description":"BaseValidation"},"IntegerValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as integer.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"IntegerValidation","type":"object"},"FloatValidation":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/BaseValidation"}],"description":"Validate input as float.","properties":{"maxValue":{"type":"number"},"minValue":{"type":"number"}},"title":"FloatValidation","type":"object"},"ExternalActionType":{"description":"The type of an external action","enum":["BLANK_LINK","FORM","COMMENT"],"type":"string","title":"ExternalActionType"},"ExternalLinkActionDefinition":{"additionalProperties":false,"description":"External Link Action.","properties":{"linkUrl":{"type":"string"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["linkUrl","type"],"title":"ExternalLinkActionDefinition","type":"object","xml":{"name":"ExternalLinkActionDefinition"}},"ExternalCommentActionDefinition":{"additionalProperties":false,"description":"This action provides a possibility to set comments. It also enables a possibility to save action results for other actions.","properties":{"isInternal":{"default":false,"description":"Whether or not this action is meant to be internally to the fulfillmenttools platform. If true, an additional entry in the actions dropdown will be added.","type":"boolean"},"type":{"$ref":"#/components/schemas/ExternalActionType"}},"required":["type"],"title":"ExternalCommentActionDefinition","type":"object","xml":{"name":"ExternalCommentActionDefinition"}},"ExternalAction":{"allOf":[{"$ref":"#/components/schemas/ExternalActionForReplacement"},{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"id":{"description":"The id of this external action. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"name":{"description":"The name of this external action.","type":"string"},"processRef":{"description":"Id of the global process related to this entity.","type":"string"}},"required":["id","name","processRef"],"type":"object","xml":{"name":"ExternalAction"},"title":"ExternalAction","description":"ExternalAction"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions/{externalActionId}":{"put":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Replaces the external action with the provided in the body.","operationId":"putExternalAction","parameters":[{"description":"ID of the external action that you want update","in":"path","name":"externalActionId","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalActionForReplacement"}}},"description":"Update external action","required":true},"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/ExternalAction"}}}},"description":"External action was found & you are allowed to update it."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Facility not found"}},"summary":"Replace an external action","tags":["External Actions (Core)"]}}}}
```

## Delete external action

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions/{externalActionId}":{"delete":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"deleteExternalAction","parameters":[{"description":"ID of the external action that you want delete","in":"path","name":"externalActionId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"External action was found & you were allowed to delete it."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"External action not found"}},"summary":"Delete external action","tags":["External Actions (Core)"]}}}}
```

## List external action logs

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Returns the logs related with the given external action.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ExternalActionLogs":{"additionalProperties":false,"properties":{"externalActionLogs":{"items":{"$ref":"#/components/schemas/ExternalActionLog"},"type":"array"},"total":{"description":"Total number of found entities for this query","type":"integer"}},"required":["externalActionLogs","total"],"type":"object","title":"ExternalActionLogs","description":"ExternalActionLogs"},"ExternalActionLog":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/ExternalActionLogForCreation"}],"properties":{"created":{"description":"The date this action has been executed","format":"date-time","type":"string"},"editor":{"$ref":"#/components/schemas/Editor"},"externalActionRef":{"description":"Id of the refered external action.","type":"string"},"id":{"type":"string"}},"required":["id","externalActionRef","editor","created"],"type":"object","xml":{"name":"ExternalActionLog"},"title":"ExternalActionLog","description":"ExternalActionLog"},"ExternalActionLogForCreation":{"properties":{"actionPayload":{"oneOf":[{"$ref":"#/components/schemas/ExternalLinkActionLogPayload"},{"$ref":"#/components/schemas/ExternalFormActionLogPayload"},{"$ref":"#/components/schemas/ExternalCommentActionLogPayload"}]},"requiresAnonymization":{"type":"boolean"}},"required":["requiresAnonymization","actionPayload"],"type":"object","xml":{"name":"ExternalActionLogForCreation"},"title":"ExternalActionLogForCreation","description":"ExternalActionLogForCreation"},"ExternalLinkActionLogPayload":{"description":"External Link Action Log Payload.","properties":{"linkOpenedAt":{"description":"The date when this link was opened.","format":"date-time","type":"string"}},"required":["linkOpenedAt"],"title":"ExternalLinkActionLogPayload","type":"object","xml":{"name":"ExternalLinkActionLogPayload"}},"ExternalFormActionLogPayload":{"description":"External Form Action Log Payload.","properties":{"elements":{"items":{"$ref":"#/components/schemas/ExternalFormActionLogPayloadElement"},"minItems":1,"type":"array"}},"required":["elements"],"title":"ExternalFormActionLogPayload","type":"object","xml":{"name":"ExternalFormActionLogPayload"}},"ExternalFormActionLogPayloadElement":{"properties":{"elementId":{"type":"string"},"value":{"type":"string"}},"required":["elementId","value"],"type":"object","xml":{"name":"ExternalFormActionLogPayloadElement"},"title":"ExternalFormActionLogPayloadElement","description":"ExternalFormActionLogPayloadElement"},"ExternalCommentActionLogPayload":{"additionalProperties":false,"description":"This action payload provides a possibility to set comments. It also enables a possibility to save action results for other actions.","properties":{"comment":{"description":"The actual comment.","minLength":1,"type":"string"},"externalActionRef":{"description":"An existing external action id you want to link with. The action have to be in the same process.","minLength":1,"type":"string"}},"required":["comment"],"title":"ExternalCommentActionLogPayload","type":"object","xml":{"name":"ExternalCommentActionLogPayload"}},"Editor":{"properties":{"userId":{"description":"ID of the user who edits the pickjob","type":"string"},"username":{"description":"username of the user who edits the pickjob","type":"string"}},"required":["username"],"type":"object","title":"Editor","description":"Editor"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions/{externalActionId}/logs":{"get":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Returns the logs related with the given external action.","operationId":"getExternalActionLogs","parameters":[{"description":"all entities after given Id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}},{"description":"Id of the external action you want to get the logs from","in":"path","name":"externalActionId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/ExternalActionLogs"},"type":"array"}}},"description":"Logs were found & you are allowed to get it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"External action logs not found"}},"summary":"List external action logs","tags":["External Actions (Core)"]}}}}
```

## Create external action logs

> Creates a new external action log.

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to attach external actions to processes and append logs to external actions.","name":"External Actions (Core)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ExternalActionLogForCreation":{"properties":{"actionPayload":{"oneOf":[{"$ref":"#/components/schemas/ExternalLinkActionLogPayload"},{"$ref":"#/components/schemas/ExternalFormActionLogPayload"},{"$ref":"#/components/schemas/ExternalCommentActionLogPayload"}]},"requiresAnonymization":{"type":"boolean"}},"required":["requiresAnonymization","actionPayload"],"type":"object","xml":{"name":"ExternalActionLogForCreation"},"title":"ExternalActionLogForCreation","description":"ExternalActionLogForCreation"},"ExternalLinkActionLogPayload":{"description":"External Link Action Log Payload.","properties":{"linkOpenedAt":{"description":"The date when this link was opened.","format":"date-time","type":"string"}},"required":["linkOpenedAt"],"title":"ExternalLinkActionLogPayload","type":"object","xml":{"name":"ExternalLinkActionLogPayload"}},"ExternalFormActionLogPayload":{"description":"External Form Action Log Payload.","properties":{"elements":{"items":{"$ref":"#/components/schemas/ExternalFormActionLogPayloadElement"},"minItems":1,"type":"array"}},"required":["elements"],"title":"ExternalFormActionLogPayload","type":"object","xml":{"name":"ExternalFormActionLogPayload"}},"ExternalFormActionLogPayloadElement":{"properties":{"elementId":{"type":"string"},"value":{"type":"string"}},"required":["elementId","value"],"type":"object","xml":{"name":"ExternalFormActionLogPayloadElement"},"title":"ExternalFormActionLogPayloadElement","description":"ExternalFormActionLogPayloadElement"},"ExternalCommentActionLogPayload":{"additionalProperties":false,"description":"This action payload provides a possibility to set comments. It also enables a possibility to save action results for other actions.","properties":{"comment":{"description":"The actual comment.","minLength":1,"type":"string"},"externalActionRef":{"description":"An existing external action id you want to link with. The action have to be in the same process.","minLength":1,"type":"string"}},"required":["comment"],"title":"ExternalCommentActionLogPayload","type":"object","xml":{"name":"ExternalCommentActionLogPayload"}},"ExternalActionLog":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/ExternalActionLogForCreation"}],"properties":{"created":{"description":"The date this action has been executed","format":"date-time","type":"string"},"editor":{"$ref":"#/components/schemas/Editor"},"externalActionRef":{"description":"Id of the refered external action.","type":"string"},"id":{"type":"string"}},"required":["id","externalActionRef","editor","created"],"type":"object","xml":{"name":"ExternalActionLog"},"title":"ExternalActionLog","description":"ExternalActionLog"},"Editor":{"properties":{"userId":{"description":"ID of the user who edits the pickjob","type":"string"},"username":{"description":"username of the user who edits the pickjob","type":"string"}},"required":["username"],"type":"object","title":"Editor","description":"Editor"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/externalactions/{externalActionId}/logs":{"post":{"description":"Creates a new external action log.","operationId":"postExternalActionLog","parameters":[{"description":"ID of the external action you want to create the log for","in":"path","name":"externalActionId","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalActionLogForCreation"}}},"description":"The external action log to be created","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExternalActionLog"}}},"description":"The log for the external action was successfully created."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"External action not found"}},"summary":"Create external action logs","tags":["External Actions (Core)"]}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fulfillmenttools.com/documentation/apis/api-reference/external-actions-core.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
